#!/usr/bin/env bash

# exit when any command fails
set -e

clean_up() {
  rm -f -r dist build ft_git ft-controllerlib.egg-info
}

trap "clean_up" ERR

# build the lib
echo "Building Library"
python3 setup.py sdist bdist_wheel

# publish the lib
echo "Publishing to Repository"
echo "Please enter your credentials for https://update.fischertechnik-cloud.com/"
python3 -m twine upload --repository-url https://update.fischertechnik-cloud.com/repository/ft-txt-lib/ dist/*

clean_up
