import connexion
import six
from flask import Response
from txtapi.models.error_message import ErrorMessage  # noqa: E501
from txtapi.models.voice_event import VoiceEvent # noqa: E501
from txtapi.handlers import remote_handler
from txtapi import util


def add_remote_event(remote_event):  # noqa: E501
    """Add a event to the running program

    Adds a event to the running program on the controller. # noqa: E501

    :param remote_event: 
    :type remote_event: dict | bytes

    :rtype: None
    """
    if connexion.request.is_json:
        remote_event = connexion.request.get_json()  # noqa: E501
    return remote_handler.add_remote_event(remote_event)


def add_voice_event(voice_event):  # noqa: E501
    """Add a text event to the running program

    Adds a text event to the running program on the controller. # noqa: E501

    :param voice_event: 
    :type voice_event: dict | bytes

    :rtype: None
    """
    if connexion.request.is_json:
        voice_event = VoiceEvent.from_dict(connexion.request.get_json())  # noqa: E501
    return remote_handler.add_voice_event(voice_event.text)


def remote_event_stream(x_api_key=None):  # noqa: E501
    """Event stream for remote control

    Message stream for events from running programs on the controller. # noqa: E501

    :param x_api_key: 
    :type x_api_key: str

    :rtype: str
    """
    return Response(remote_handler.remote_event_stream(), mimetype='text/event-stream')


def send_command(command):  # noqa: E501
    """DEPRICATED - Add a text to the running program

    DEPRICATED - Adds a text to the running program on the controller. # noqa: E501

    :param command: The voicecommand to be executed
    :type command: str

    :rtype: None
    """
    return remote_handler.add_voice_event(command)
