import json
import time
import socket

from http import HTTPStatus
from fischertechnik.control.VoiceControl import VoiceControl
from fischertechnik.control.RemoteControl import RemoteControl


def add_voice_event(event):

    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.connect((VoiceControl.HOST, VoiceControl.PORT))
        s.send(event.encode('utf-8'))
    except Exception as e:
        pass
    finally:
        s.close()

    return None, HTTPStatus.OK


def add_remote_event(event):

    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.connect((RemoteControl.HOST, RemoteControl.IN_PORT))
        message = json.dumps(event)
        s.send(message.encode('utf-8'))
    except Exception as e:
        pass
    finally:
        s.close()

    return None, HTTPStatus.OK


def remote_event_stream():

    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    while True:
        try: 
            s.connect((RemoteControl.HOST, RemoteControl.OUT_PORT))
            break
        except Exception as e:
            time.sleep(1)

    running = True
    while running:

        try:    

            data = s.recv(RemoteControl.BUFFERSIZE) 

            if (data != b''):

                yield 'data: %s\n\n' % str(data.decode())     

        except Exception as e:
            running = False

    print("command stream closed")

    return None, HTTPStatus.OK
