import subprocess
from http import HTTPStatus

from txtapi.handlers import application_handler
from txtapi.handlers import controller_handler
from txtapi.handlers import debugger_handler
from txtapi.utility.heartbeat.heartbeat import Heartbeat


def ping():
    Heartbeat.get_instance().keep_alive()
    role = get_controller_role()
    if role == 'Master' or role == 'Single':
        return None, HTTPStatus.OK
    return 'Controller is in extension mode', HTTPStatus.CONFLICT

def stop():
    application_handler.stop_applications()
    controller_handler.stop_controller()
    debugger_handler.stop_debuggers()

def get_controller_role():
    output = str(subprocess.Popen(['ftconfig', 'dump'], stdout=subprocess.PIPE,
                                  stderr=subprocess.STDOUT).communicate()[0]).replace('\\n', '')
    start = output.find('name ') + 5
    end = output.find('sn', start)
    return output[start:end]


