# coding: utf-8

from __future__ import absolute_import

from flask import json
from six import BytesIO

from txtapi.models.inline_response_default import InlineResponseDefault  # noqa: E501
from txtapi.test import BaseTestCase


class TestApplicationController(BaseTestCase):
    """ApplicationController integration test stubs"""

    def test_abort_project(self):
        """Test case for abort_project

        
        """
        query_string = [('workspace_name', 'workspace_name_example')]
        response = self.client.open(
            '/v1/abort',
            method='POST',
            content_type='text/plain',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_delete_file(self):
        """Test case for delete_file

        
        """
        query_string = [('workspace_name', 'workspace_name_example'),
                        ('path', 'path_example')]
        response = self.client.open(
            '/v1/delete',
            method='DELETE',
            content_type='text/plain',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_run_project(self):
        """Test case for run_project

        
        """
        query_string = [('workspace_name', 'workspace_name_example')]
        response = self.client.open(
            '/v1/run',
            method='POST',
            content_type='text/plain',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_send_file(self):
        """Test case for send_file

        
        """
        query_string = [('workspace_name', 'workspace_name_example'),
                        ('path', 'path_example')]
        data = dict(file=(BytesIO(b'some file data'), 'file.txt'))
        response = self.client.open(
            '/v1/files',
            method='POST',
            data=data,
            content_type='multipart/form-data',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    import unittest
    unittest.main()
