from enum import Enum
class Command(Enum):
    NEXT = "n"  # step to next line in the code
    STEP = "s"  # step to next line or into called function
    CONT = "c"  # continue to next breakpoint
    RETURN = "r"    # continue to the end of the function
    QUIT = "q"  # stop debugging
    WHERE = "w" # print call stack
    CLEAR = "cl"    # clear all breakpoints
    BREAK = "b" # list all breakpoints
    YES = "y"   # Confirmation, e.g. to delete all breakpoints
    DISABLE = "disable" # disable a breakpoint
    ENABLE = "enable"   # enable a breakpoint
    GLOBALS = "import json;{json.dumps(str(k)): json.dumps([str(v), str(type(v))]) for k,v in globals().items()}"
    LOCALS  = "import json;{json.dumps(str(k)): json.dumps([str(v), str(type(v))]) for k,v in locals().items()}"
    ALIAS = "alias"     # create an alias that executes a command
    UNALIAS = "unalias" # delete an alias
    DOWN = "d"  # Move down in the current call stack (to a newer frame)
    UP = "u"    # Move up in the current call stack (to an older frame)
